
package de.ivu.elect.presentation.wahlvorschlagsperson;

import javax.annotation.PostConstruct;
import javax.inject.Inject;

import de.ivu.elect.business.kandidatur.boundary.KandidaturConversationSelect;
import de.ivu.elect.business.kandidatur.entity.Kandidatur;
import de.ivu.elect.business.person.entity.Personendaten;
import de.ivu.elect.business.personenregister.boundary.PersonenregisterByPersonendatenSearchParameters;
import de.ivu.elect.business.personenregister.boundary.PersonenregisterPersonendatenConversationSelect;
import de.ivu.elect.business.personenregister.control.WahlvorschlagsPersonPersonenregisterPersonendatenMapper;
import de.ivu.elect.business.personenregister.entity.PersonenregisterPersonendaten;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.business.wahlvorschlag.boundary.WahlvorschlagConversationSelect;
import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag;
import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonConversationSelect;
import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonPoolCreate;
import de.ivu.elect.business.wahlvorschlagsperson.control.WahlvorschlagsPersonPoolPersonendatenMapper;
import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson;
import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonTyp;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.person.PersonendatenFormatter;
import de.ivu.elect.presentation.wahlvorschlagsperson.form.AbstractWahlvorschlagsPersonViewFormBuilder;
import de.ivu.elect.util.StringJoiner;

public abstract class AbstractDynaFormWahlvorschlagsPersonCreateView extends AbstractWahlvorschlagsPersonCreateView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlvorschlagConversationSelect wahlvorschlagConversationSelect;

  @Inject
  private transient KandidaturConversationSelect kandidaturConversationSelect;

  @Inject
  private transient WahlvorschlagsPersonPoolCreate wahlvorschlagsPersonPoolCreate;

  @Inject
  private transient WahlvorschlagsPersonConversationSelect wahlvorschlagsPersonPoolPersonendatenSelect;

  @Inject
  private transient WahlvorschlagsPersonPoolPersonendatenMapper wahlvorschlagsPersonPoolPersonendatenMapper;

  @Inject
  private transient PersonenregisterPersonendatenConversationSelect personenregisterPersonendatenSelect;

  @Inject
  private transient WahlvorschlagsPersonPersonenregisterPersonendatenMapper wahlvorschlagsPersonPersonenregisterPersonendatenMapper;

  @Inject
  private transient PersonendatenFormatter personendatenFormatter;

  public AbstractDynaFormWahlvorschlagsPersonCreateView() {
    super();
  }

  @PreConditionCheck
  public String checkPreCondition() {
    return getWahlvorschlagspersonCreateViewHelper().checkPreCondition();
  }

  private Wahlvorschlag getWahlvorschlag() {
    return wahlvorschlagConversationSelect.getEntity();
  }

  public String getWahlvorschlagKennwort() {
    String kennwort = getWahlvorschlag().getKennwort();
    if (isIndividuelleWahlvorschlagsPerson()) {
      kennwort = StringJoiner.joinWithCustomSeparator(" - ", kennwort, getKandidaturName());
    }
    return kennwort;
  }

  private Kandidatur getKandidatur() {
    return kandidaturConversationSelect.getEntity();
  }

  private String getKandidaturName() {
    return personendatenFormatter.getVornameUndFamiliennameFuerAnzeige(getKandidatur());
  }

  private boolean isIndividuelleWahlvorschlagsPerson() {
    return getKandidatur() != null;
  }

  protected abstract WahlvorschlagsPersonTyp getInitialierWahlvorschlagsPersonTyp(boolean individuelleWahlvorschlagsPerson);

  private boolean isEntityReadonly() {
    // NOTE, dass beim Kopieren einer bestehenden WahlvorschlagsPerson die neu anzulegende WahlvorschlagsPerson nie
    // editierbar ist.
    return isWahlvorschlagsPersonPoolPersonendatenSelected();
  }

  @Override
  @PostConstruct
  public void init() {
    super.init();

    WahlvorschlagsPerson wahlvorschlagsPerson = getEntity();
    Wahlvorschlag wahlvorschlag = getWahlvorschlag();

    wahlvorschlagsPerson.setWahlvorschlag(wahlvorschlag);
    wahlvorschlagsPerson.setWahl(wahlvorschlag.getWahl()); // einige Properties ziehen Informationen daraus
    wahlvorschlagsPerson.setWahlvorschlagsPersonTyp(getInitialierWahlvorschlagsPersonTyp(isIndividuelleWahlvorschlagsPerson()));

    wahlvorschlagsPerson.setKandidatur(getKandidatur());

    tryPresetPersonendaten();
  }

  private void tryPresetPersonendaten() {
    if (isPersonenregisterPersonendatenSelected()) {
      initPersonenregisterPersonendaten(getPersonenregisterPersonendaten());
    } else if (isPersonenregisterByPersonendatenSearchParametersSelected()) {
      initPersonenregisterPersonendaten(getPersonenregisterByPersonendatenSearchParameters());
    } else if (isWahlvorschlagsPersonPoolPersonendatenSelected()) {
      initWahlvorschlagsPersonPoolPersonendaten(getWahlvorschlagsPersonPoolPersonendaten());
    }
  }

  private boolean isPersonenregisterPersonendatenSelected() {
    return personenregisterPersonendatenSelect.isPersonenregisterPersonendatenSelected();
  }

  private PersonenregisterPersonendaten getPersonenregisterPersonendaten() {
    return personenregisterPersonendatenSelect.getPersonenregisterPersonendaten();
  }

  private void initPersonenregisterPersonendaten(PersonenregisterPersonendaten personenregisterPersonendaten) {
    Personendaten personendaten = getEntity();

    wahlvorschlagsPersonPersonenregisterPersonendatenMapper.mapManuelleAuswahl(personendaten, personenregisterPersonendaten);
    getWahlvorschlagsPersonViewFormBuilder().tryAttachStaatsangehoerigkeiten(personendaten);
  }

  private boolean isPersonenregisterByPersonendatenSearchParametersSelected() {
    return personenregisterPersonendatenSelect.isPersonenregisterByPersonendatenSearchParametersSelected();
  }

  private PersonenregisterByPersonendatenSearchParameters getPersonenregisterByPersonendatenSearchParameters() {
    return personenregisterPersonendatenSelect.getPersonenregisterByPersonendatenSearchParameters();
  }

  private void initPersonenregisterPersonendaten(PersonenregisterByPersonendatenSearchParameters searchParameters) {
    Personendaten personendaten = getEntity();
    personendaten.setFamilienname(searchParameters.getFamilienname());
    personendaten.setRufname(searchParameters.getVorname());
    personendaten.setGeburtsdatum(searchParameters.getGeburtsdatum());
    personendaten.setGeschlecht(searchParameters.getGeschlecht());
  }

  private boolean isWahlvorschlagsPersonPoolPersonendatenSelected() {
    return wahlvorschlagsPersonPoolPersonendatenSelect.isSelected();
  }

  private WahlvorschlagsPerson getWahlvorschlagsPersonPoolPersonendaten() {
    return wahlvorschlagsPersonPoolPersonendatenSelect.getEntity();
  }

  private void initWahlvorschlagsPersonPoolPersonendaten(WahlvorschlagsPerson wahlvorschlagsPersonPoolPersonendaten) {
    wahlvorschlagsPersonPoolPersonendatenMapper.map(getEntity(), getWahlvorschlagsPersonPoolPersonendaten());
  }

  @Override
  public void addProperties(FormBuilder formBuilder, WahlvorschlagsPerson wahlvorschlagsPerson) {
    getWahlvorschlagsPersonViewFormBuilder().addProperties(formBuilder, wahlvorschlagsPerson, isEntityReadonly());
  }

  protected abstract AbstractWahlvorschlagsPersonViewFormBuilder getWahlvorschlagsPersonViewFormBuilder();

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLVORSCHLAGS_PERSON_CREATE)
  public String save() {
    if (isWahlvorschlagsPersonPoolPersonendatenSelected()) {
      wahlvorschlagsPersonPoolCreate.create(getEntity(), getWahlvorschlagsPersonPoolPersonendaten());

      addMessageSaveSuccess(getEntity());

      return goBack(getParentViewId());
    }

    return super.save();
  }

  @Override
  public boolean isBtnResetRendered() {
    return super.isBtnResetRendered() && !isEntityReadonly();
  }

  @Override
  @Redirect
  public String goBack() {
    super.goBack();

    if (isWahlvorschlagsPersonPoolPersonendatenSelected()) {
      wahlvorschlagsPersonPoolPersonendatenSelect.clearEntity();
    }

    if (personenregisterPersonendatenSelect.isSelected()) {
      personenregisterPersonendatenSelect.clear();
    }

    return getParentViewId();
  }

  protected abstract AbstractWahlvorschlagspersonCreateViewHelper getWahlvorschlagspersonCreateViewHelper();
}
